/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
import * as o from "react";
import e from "prop-types";
import { Popup as et } from "@progress/kendo-react-popup";
import { cloneDate as oe, getDate as tt } from "@progress/kendo-date-math";
import { validatePackage as nt, useId as ot, useAdaptiveModeContext as rt, usePropsContext as at, canUseDOM as re, AsyncFocusBlur as lt, classNames as ae, kendoThemeMaps as le, createPropsContext as it, Keys as O } from "@progress/kendo-react-common";
import { calendarIcon as ut } from "@progress/kendo-svg-icons";
import { packageMetadata as st } from "../package-metadata.mjs";
import { DateInput as ct } from "../dateinput/DateInput.mjs";
import { Calendar as dt } from "../calendar/components/Calendar.mjs";
import { nullable as a, MAX_DATE as ft, MIN_DATE as mt, isInDateRange as pt, setTime as gt } from "../utils.mjs";
import { toggleCalendar as ie, messages as ht } from "../messages/index.mjs";
import { useLocalization as vt } from "@progress/kendo-react-intl";
import { ToggleButton as wt } from "./ToggleButton.mjs";
import { PickerWrap as bt } from "../common/PickerWrap.mjs";
import { PickerFloatingLabel as yt } from "../hooks/usePickerFloatingLabel.mjs";
import { ActionSheetContent as Ct } from "@progress/kendo-react-layout";
import { AdaptiveMode as kt } from "../common/AdaptiveMode.mjs";
const ue = o.forwardRef((n, se) => {
  nt(st);
  const N = ot(n.id), ce = vt(), g = rt(), {
    defaultShow: de = l.defaultShow,
    defaultValue: fe = l.defaultValue,
    dateInput: me = l.dateInput,
    calendar: pe = l.calendar,
    toggleButton: ge = l.toggleButton,
    popup: he = l.popup,
    pickerWrap: Ot = l.pickerWrap,
    disabled: h = l.disabled,
    format: ve = l.format,
    max: R = l.max,
    min: I = l.min,
    popupSettings: v = l.popupSettings,
    tabIndex: we = l.tabIndex,
    weekNumber: be = l.weekNumber,
    validityStyles: z = l.validityStyles,
    size: S = l.size,
    rounded: E = l.rounded,
    fillMode: x = l.fillMode,
    autoFocus: ye = l.autoFocus,
    show: W,
    autoSwitchParts: Ce,
    autoSwitchKeys: ke,
    twoDigitYearMax: De,
    ariaLabel: Oe,
    adaptive: Mt,
    adaptiveTitle: Me,
    inputAttributes: Pe,
    validationMessage: L,
    visited: Pt,
    value: _,
    touched: Rt,
    modified: It,
    _adaptiveMode: St = g,
    valid: K,
    focusedDate: Re,
    id: Ie,
    ...q
  } = at(Dt, n), B = () => {
    if (re)
      return b.current && b.current.ownerDocument || window.document;
  }, s = () => !!(p.windowWidth && g && p.windowWidth <= (g == null ? void 0 : g.medium) && n.adaptive), d = () => {
    const t = C.current !== void 0 && C.current !== null ? C.current : _ !== void 0 ? _ : p.value;
    return t !== null ? oe(t) : null;
  }, i = () => M.current !== void 0 ? M.current : W !== void 0 ? W : p.show, Se = () => me || l.dateInput, Ee = () => ge || l.toggleButton, xe = () => pe || l.calendar, _e = () => he || l.popup, H = () => n.required !== void 0 ? n.required : !1, T = () => {
    const t = d() || _ || null, r = I, u = R, P = pt(t, r, u), A = L !== void 0, V = (!H() || t != null) && P, F = K !== void 0 ? K : V;
    return {
      customError: A,
      rangeOverflow: t && u.getTime() < t.getTime() || !1,
      rangeUnderflow: t && t.getTime() < r.getTime() || !1,
      valid: F,
      valueMissing: t === null
    };
  }, Be = (t) => {
    for (const r of t)
      D({ windowWidth: r.target.clientWidth });
  }, Te = () => {
    c.current && c.current.focus();
  }, U = (t) => {
    y.current = t;
  }, f = (t) => {
    i() !== t && (D({ show: t }), t && n.onOpen && n.onOpen.call(void 0, { target: w.current }), !t && n.onClose && n.onClose.call(void 0, { target: w.current }));
  }, Ae = (t) => {
    const r = d();
    return r && t ? gt(t, r) : t;
  }, Ve = (t) => {
    v != null && v.onMouseDownOutside && v.onMouseDownOutside.call(void 0, t);
  }, Y = (t, r) => {
    D({ value: oe(t || void 0) }), C.current = t, M.current = !1, s() || (m.current = !0), n.onChange && n.onChange.call(void 0, {
      syntheticEvent: r.syntheticEvent,
      nativeEvent: r.nativeEvent,
      value: d(),
      show: i(),
      target: w.current
    }), C.current = void 0, M.current = void 0, f(!1);
  }, Fe = (t) => {
    const r = Ae(t.value);
    Y(r, t);
  }, $ = () => {
    const { popupClass: t, ...r } = v, u = i(), P = d(), A = P && tt(P), V = ae(t), F = {
      popupClass: "k-datepicker-popup",
      show: u,
      anchor: b.current,
      className: V,
      id: G,
      anchorAlign: {
        horizontal: "left",
        vertical: "bottom"
      },
      popupAlign: {
        horizontal: "left",
        vertical: "top"
      },
      ...r,
      onMouseDownOutside: Ve
    }, te = {
      disabled: h,
      value: A,
      min: I,
      max: R,
      weekNumber: be,
      focusedDate: Re,
      className: s() ? "k-calendar-lg" : "",
      navigation: !s(),
      onChange: Fe
    }, ne = xe(), Qe = _e();
    return s() ? /* @__PURE__ */ o.createElement(ne, { _ref: U, ...te }) : /* @__PURE__ */ o.createElement(Qe, { ...F }, /* @__PURE__ */ o.createElement(ne, { _ref: U, ...te }));
  }, j = () => {
    D({ focused: !1 }), f(!1);
  }, Ne = () => {
    const { windowWidth: t = 0 } = p, r = {
      expand: i(),
      onClose: j,
      adaptiveTitle: Me,
      windowWidth: t
    }, u = $();
    return /* @__PURE__ */ o.createElement(kt, { ...r }, /* @__PURE__ */ o.createElement(Ct, { overflowHidden: !0 }, u));
  }, ze = (t) => {
    Y(t.value, t);
  }, We = () => {
    D({ focused: !0 });
  }, Le = () => {
    f(!i());
  }, X = () => {
    h || (m.current = !0, f(!i()));
  }, Ke = (t) => {
    t.preventDefault();
  }, qe = (t) => {
    const { altKey: r, keyCode: u } = t;
    if (u === O.esc && i()) {
      m.current = !0, f(!1);
      return;
    }
    r && (u === O.up || u === O.down) && (t.preventDefault(), t.stopPropagation(), m.current = u === O.up, f(u === O.down));
  }, w = o.useRef(null), b = o.useRef(null), c = o.useRef(null), y = o.useRef(null);
  o.useImperativeHandle(
    w,
    () => ({
      props: n,
      get element() {
        return b.current;
      },
      get calendar() {
        return y.current;
      },
      get dateInput() {
        return c.current;
      },
      get name() {
        return n.name;
      },
      get show() {
        return i();
      },
      get validity() {
        return T();
      },
      get value() {
        return d();
      },
      get mobileMode() {
        return s();
      },
      togglePopup: Le,
      // Hidden Methods but still accessible
      focus: Te
    })
  ), o.useImperativeHandle(se, () => w.current);
  const C = o.useRef(null), M = o.useRef(void 0), He = o.useRef(null), m = o.useRef(!1), Z = o.useRef(!1), k = o.useRef(null), [p, Ue] = o.useState({
    value: fe,
    show: de,
    focused: !1
  }), [, Ye] = o.useReducer((t) => t, !0), D = (t) => {
    Ue((r) => ({ ...r, ...t }));
  };
  o.useEffect(() => {
    y.current && y.current.element && i() && !Z.current && y.current.element.focus({ preventScroll: !0 }), c.current && c.current.element && !i() && m.current && c.current.element.focus({ preventScroll: !0 }), Z.current = i(), m.current = !1;
  }), o.useEffect(() => {
    var t;
    return k.current = re && window.ResizeObserver && new window.ResizeObserver((r) => Be(r)), i() && Ye(), (t = B()) != null && t.body && k.current && k.current.observe(B().body), () => {
      var r;
      clearTimeout(He.current), (r = B()) != null && r.body && k.current && k.current.disconnect();
    };
  }, []);
  const G = N + "-popup-id", $e = $(), je = Se(), Xe = d(), Ze = Ee(), Ge = Ne(), J = !z || T().valid, Q = ce.toLanguageString(ie, ht[ie]), Je = {
    disabled: h,
    format: ve,
    formatPlaceholder: n.formatPlaceholder,
    id: Ie,
    ariaLabelledBy: n.ariaLabelledBy,
    ariaDescribedBy: n.ariaDescribedBy,
    ariaLabel: Oe,
    max: R,
    min: I,
    name: n.name,
    onChange: ze,
    required: n.required,
    _ref: c,
    tabIndex: i() ? -1 : we,
    title: n.title,
    valid: T().valid,
    validationMessage: L,
    validityStyles: z,
    value: Xe,
    label: void 0,
    placeholder: p.focused ? null : n.placeholder,
    ariaExpanded: i(),
    size: null,
    fillMode: null,
    rounded: null,
    autoFill: n.autoFill,
    twoDigitYearMax: De,
    enableMouseWheel: n.enableMouseWheel,
    autoCorrectParts: n.autoCorrectParts,
    autoSwitchParts: Ce,
    autoSwitchKeys: ke,
    allowCaretMode: n.allowCaretMode,
    inputAttributes: Pe
  }, ee = /* @__PURE__ */ o.createElement(
    lt,
    {
      onFocus: We,
      onBlur: s() ? void 0 : j,
      onSyncBlur: n.onBlur,
      onSyncFocus: n.onFocus
    },
    (t) => /* @__PURE__ */ o.createElement(o.Fragment, null, /* @__PURE__ */ o.createElement(
      "span",
      {
        ...n.label ? {} : q,
        ref: b,
        className: ae(
          "k-input",
          "k-datepicker",
          {
            [`k-input-${le.sizeMap[S] || S}`]: S,
            [`k-rounded-${le.roundedMap[E] || E}`]: E,
            [`k-input-${x}`]: x,
            "k-invalid": !J,
            "k-required": H(),
            "k-disabled": h
          },
          n.className
        ),
        onKeyDown: qe,
        style: { width: n.width },
        onFocus: t.onFocus,
        onBlur: t.onBlur,
        onClick: s() ? X : void 0
      },
      /* @__PURE__ */ o.createElement(
        je,
        {
          _ref: c,
          ariaRole: "combobox",
          ariaExpanded: i(),
          ariaControls: G,
          autoFocus: ye,
          ...Je
        }
      ),
      /* @__PURE__ */ o.createElement(
        Ze,
        {
          type: "button",
          icon: "calendar",
          svgIcon: ut,
          title: Q,
          className: "k-input-button",
          rounded: null,
          onClick: s() ? void 0 : X,
          "aria-label": Q,
          fillMode: x,
          onMouseDown: Ke
        }
      ),
      !s() && $e
    ), s() && Ge)
  );
  return n.label ? /* @__PURE__ */ o.createElement(
    yt,
    {
      dateInput: c,
      label: n.label,
      editorId: N,
      editorValid: J,
      editorDisabled: h,
      children: ee,
      style: { width: n.width },
      ...q
    }
  ) : ee;
});
ue.propTypes = {
  className: e.string,
  defaultShow: e.bool,
  defaultValue: e.instanceOf(Date),
  disabled: e.bool,
  focusedDate: e.instanceOf(Date),
  format: e.oneOfType([
    e.string,
    e.shape({
      skeleton: a(e.string),
      pattern: a(e.string),
      date: a(e.oneOf(["short", "medium", "long", "full"])),
      time: a(e.oneOf(["short", "medium", "long", "full"])),
      datetime: a(e.oneOf(["short", "medium", "long", "full"])),
      era: a(e.oneOf(["narrow", "short", "long"])),
      year: a(e.oneOf(["numeric", "2-digit"])),
      month: a(e.oneOf(["numeric", "2-digit", "narrow", "short", "long"])),
      day: a(e.oneOf(["numeric", "2-digit"])),
      weekday: a(e.oneOf(["narrow", "short", "long"])),
      hour: a(e.oneOf(["numeric", "2-digit"])),
      hour12: a(e.bool),
      minute: a(e.oneOf(["numeric", "2-digit"])),
      second: a(e.oneOf(["numeric", "2-digit"])),
      timeZoneName: a(e.oneOf(["short", "long"]))
    })
  ]),
  formatPlaceholder: e.oneOfType([
    a(
      e.oneOf(["wide", "narrow", "short", "formatPattern"])
    ),
    e.shape({
      year: a(e.string),
      month: a(e.string),
      day: a(e.string),
      hour: a(e.string),
      minute: a(e.string),
      second: a(e.string)
    })
  ]),
  id: e.string,
  ariaLabelledBy: e.string,
  ariaDescribedBy: e.string,
  ariaLabel: e.string,
  min: e.instanceOf(Date),
  max: e.instanceOf(Date),
  name: e.string,
  popupSettings: e.shape({
    animate: a(e.bool),
    appendTo: a(e.any),
    popupClass: a(e.string)
  }),
  show: e.bool,
  tabIndex: e.number,
  title: e.string,
  value: e.instanceOf(Date),
  weekNumber: e.bool,
  width: e.oneOfType([e.number, e.string]),
  validationMessage: e.string,
  required: e.bool,
  valid: e.bool,
  size: e.oneOf([null, "small", "medium", "large"]),
  rounded: e.oneOf([null, "small", "medium", "large", "full"]),
  fillMode: e.oneOf([null, "solid", "flat", "outline"]),
  adaptive: e.bool,
  adaptiveTitle: e.string,
  autoFocus: e.bool,
  inputAttributes: e.object
};
const l = {
  defaultShow: !1,
  defaultValue: null,
  dateInput: ct,
  calendar: dt,
  toggleButton: wt,
  popup: et,
  pickerWrap: bt,
  disabled: !1,
  format: "d",
  max: ft,
  min: mt,
  popupSettings: {},
  tabIndex: 0,
  weekNumber: !1,
  validityStyles: !0,
  size: "medium",
  rounded: "medium",
  fillMode: "solid",
  autoFocus: !1
}, Dt = it();
ue.displayName = "KendoReactDatePicker";
export {
  ue as DatePicker,
  Dt as DatePickerPropsContext,
  l as datePickerDefaultProps
};
